std::bitset< _Nb > Class Template Reference
Utilities

`#include <bitset>`

Inheritance diagram for std::bitset< _Nb >:
[legend]

## Classes

class | reference

## Public Member Functions

constexpr | bitset () noexcept
template<typename _CharT >
constexpr | bitset (const _CharT *__str, typename __bitset::__string< _CharT >::size_type __n=__bitset::__string< _CharT >::npos, _CharT __zero=_CharT('0'), _CharT __one=_CharT('1'))
template<class _CharT , class _Traits , class _Alloc >
constexpr | bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position, size_t __n)
template<class _CharT , class _Traits , class _Alloc >
constexpr | bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position, size_t __n, _CharT __zero, _CharT __one=_CharT('1'))
template<class _CharT , class _Traits , class _Alloc >
constexpr | bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position=0)
constexpr | bitset (unsigned long long __val) noexcept
constexpr size_t | _Find_first () const noexcept
constexpr size_t | _Find_next (size_t __prev) const noexcept
constexpr bool | all () const noexcept
constexpr bool | any () const noexcept
constexpr size_t | count () const noexcept
constexpr bitset< _Nb > & | flip () noexcept
constexpr bitset< _Nb > & | flip (size_t __position)
constexpr bool | none () const noexcept
constexpr bitset< _Nb > | operator~ () const noexcept
constexpr bitset< _Nb > & | reset () noexcept
constexpr bitset< _Nb > & | reset (size_t __position)
constexpr bitset< _Nb > & | set () noexcept
constexpr bitset< _Nb > & | set (size_t __position, bool __val=true)
constexpr size_t | size () const noexcept
constexpr bool | test (size_t __position) const
template<class _CharT , class _Traits , class _Alloc >
constexpr std::basic_string< _CharT, _Traits, _Alloc > | to_string () const
template<class _CharT , class _Traits >
constexpr std::basic_string< _CharT, _Traits, std::allocator< _CharT > > | to_string () const
template<class _CharT >
constexpr std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > | to_string () const
constexpr std::basic_string< char, std::char_traits< char >, std::allocator< char > > | to_string () const
template<class _CharT , class _Traits , class _Alloc >
constexpr std::basic_string< _CharT, _Traits, _Alloc > | to_string (_CharT __zero, _CharT __one=_CharT('1')) const
template<class _CharT , class _Traits >
constexpr std::basic_string< _CharT, _Traits, std::allocator< _CharT > > | to_string (_CharT __zero, _CharT __one=_CharT('1')) const
template<class _CharT >
constexpr std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > | to_string (_CharT __zero, _CharT __one=_CharT('1')) const
constexpr std::basic_string< char, std::char_traits< char >, std::allocator< char > > | to_string (char __zero, char __one='1') const
constexpr unsigned long long | to_ullong () const
constexpr unsigned long | to_ulong () const
constexpr bitset< _Nb > & | operator&= (const bitset< _Nb > &__rhs) noexcept
constexpr bitset< _Nb > & | operator|= (const bitset< _Nb > &__rhs) noexcept
constexpr bitset< _Nb > & | operator^= (const bitset< _Nb > &__rhs) noexcept
constexpr bitset< _Nb > & | operator<<= (size_t __position) noexcept
constexpr bitset< _Nb > & | operator>>= (size_t __position) noexcept
constexpr bitset< _Nb > & | _Unchecked_set (size_t __pos) noexcept
constexpr bitset< _Nb > & | _Unchecked_set (size_t __pos, int __val) noexcept
constexpr bitset< _Nb > & | _Unchecked_reset (size_t __pos) noexcept
constexpr bitset< _Nb > & | _Unchecked_flip (size_t __pos) noexcept
constexpr bool | _Unchecked_test (size_t __pos) const noexcept
constexpr reference | operator[] (size_t __position)
constexpr bool | operator[] (size_t __position) const
constexpr bool | operator== (const bitset< _Nb > &__rhs) const noexcept
constexpr bitset< _Nb > | operator<< (size_t __position) const noexcept
constexpr bitset< _Nb > | operator>> (size_t __position) const noexcept

## Friends

template<class _CharT , class _Traits , size_t _Nb2>
std::basic_ostream< _CharT, _Traits > & | operator<< (std::basic_ostream< _CharT, _Traits > &, const bitset< _Nb2 > &)
template<class _CharT , class _Traits , size_t _Nb2>
std::basic_istream< _CharT, _Traits > & | operator>> (std::basic_istream< _CharT, _Traits > &, bitset< _Nb2 > &)
class | reference
struct | std::hash< bitset >

## Detailed Description

template<size_t _Nb>
class std::bitset< _Nb >

The bitset class represents a fixed-size sequence of bits.

(Note that bitset does not meet the formal requirements of a container. Mainly, it lacks iterators.)

The template argument, Nb, may be any non-negative number, specifying the number of bits (e.g., "0", "12", "1024*1024").

In the general unoptimized case, storage is allocated in word-sized blocks. Let B be the number of bits in a word, then (Nb+(B-1))/B words will be used for storage. B - NbB bits are unused. (They are the high-order bits in the highest word.) It is a class invariant that those unused bits are always zero.

If you think of bitset as a simple array of bits, be aware that your mental picture is reversed: a bitset behaves the same way as bits in integers do, with the bit at index 0 in the least significant / right-hand position, and the bit at index Nb-1 in the most significant / left-hand position. Thus, unlike other containers, a bitset's index counts from right to left, to put it very loosely.

This behavior is preserved when translating to and from strings. For example, the first line of the following program probably prints b('a') is 0001100001 on a modern ASCII system.

#include <bitset>
#include <iostream>
#include <sstream>
using namespace std;
int main()
{
long a = 'a';
bitset<10> b(a);
cout << "b('a') is " << b << endl;
ostringstream s;
s << b;
string str = s.str();
cout << "index 3 in the string is " << str[3] << " but\n"
<< "index 3 in the bitset is " << b[3] << endl;
}

Also see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/ext_containers.html for a description of extensions.

Most of the actual code isn't contained in bitset<> itself, but in the base class _Base_bitset. The base class works with whole words, not with individual bits. This allows us to specialize _Base_bitset for the important special case where the bitset is only a single word.

Extra confusion can result due to the fact that the storage for _Base_bitset is a regular array, and is indexed as such. This is carefully encapsulated.

Definition at line 804 of file bitset.

## Constructor & Destructor Documentation

## bitset() [1/6]

template<size_t _Nb>

constexpr std::bitset< _Nb >::bitset | ( |  | ) |

inline constexpr noexcept

All bits set to zero.

Definition at line 936 of file bitset.

## bitset() [2/6]

template<size_t _Nb>

constexpr std::bitset< _Nb >::bitset | ( | unsigned long long | __val | ) |

inline constexpr noexcept

Initial bits bitwise-copied from a single word (others set to zero).

Definition at line 941 of file bitset.

## bitset() [3/6]

template<size_t _Nb>
template<class _CharT , class _Traits , class _Alloc >

constexpr std::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position = `0`
| ) |  |

inline explicit constexpr

Use a subset of a string.

Parameters

  __s | A string of 0 and 1 characters.
  __position | Index of the first character in __s to use; defaults to zero.

Exceptions

  std::out_of_range | If pos is bigger the size of __s.
  std::invalid_argument | If a character appears in the string which is neither 0 nor 1.

Definition at line 962 of file bitset.

## bitset() [4/6]

template<size_t _Nb>
template<class _CharT , class _Traits , class _Alloc >

constexpr std::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position,
|  | size_t | __n
| ) |  |

inline constexpr

Use a subset of a string.

Parameters

  __s | A string of 0 and 1 characters.
  __position | Index of the first character in __s to use.
  __n | The number of characters to copy.

Exceptions

  std::out_of_range | If __position is bigger the size of __s.
  std::invalid_argument | If a character appears in the string which is neither 0 nor 1.

Definition at line 984 of file bitset.

## bitset() [5/6]

template<size_t _Nb>
template<class _CharT , class _Traits , class _Alloc >

constexpr std::bitset< _Nb >::bitset | ( | const std::basic_string< _CharT, _Traits, _Alloc > & | __s,
|  | size_t | __position,
|  | size_t | __n,
|  | _CharT | __zero,
|  | _CharT | __one = `_CharT('1')`
| ) |  |

inline constexpr

Definition at line 996 of file bitset.

## bitset() [6/6]

template<size_t _Nb>
template<typename _CharT >

constexpr std::bitset< _Nb >::bitset | ( | const _CharT * | __str,
|  | typename __bitset< _Nb >::__string< _CharT >::size_type | __n = `__bitset< _Nb >::__string<_CharT>::npos`,
|  | _CharT | __zero = `_CharT('0')`,
|  | _CharT | __one = `_CharT('1')`
| ) |  |

inline explicit constexpr

Construct from a character array.

Parameters

  __str | An array of characters zero and one.
  __n | The number of characters to use.
  __zero | The character corresponding to the value 0.
  __one | The character corresponding to the value 1.

Exceptions

  std::invalid_argument | If a character appears in the string which is neither __zero nor __one.

Definition at line 1020 of file bitset.

## Member Function Documentation

## all()

template<size_t _Nb>

constexpr bool std::bitset< _Nb >::all | ( |  | ) | const

inline constexpr noexcept

Tests whether all the bits are on.

Returns
  True if all the bits are set.

Definition at line 1411 of file bitset.

## any()

template<size_t _Nb>

constexpr bool std::bitset< _Nb >::any | ( |  | ) | const

inline constexpr noexcept

Tests whether any of the bits are on.

Returns
  True if at least one bit is set.

Definition at line 1420 of file bitset.

## count()

template<size_t _Nb>

constexpr size_t std::bitset< _Nb >::count | ( |  | ) | const

inline constexpr noexcept

Returns the number of bits which are set.

Definition at line 1366 of file bitset.

## flip() [1/2]

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::flip | ( |  | ) |

inline constexpr noexcept

Toggles every bit to its opposite value.

Definition at line 1209 of file bitset.

## flip() [2/2]

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::flip | ( | size_t | __position | ) |

inline constexpr

Toggles a given bit to its opposite value.

Parameters

  __position | The index of the bit.

Exceptions

  std::out_of_range | If pos is bigger the size of the set.

Definition at line 1223 of file bitset.

## none()

template<size_t _Nb>

constexpr bool std::bitset< _Nb >::none | ( |  | ) | const

inline constexpr noexcept

Tests whether any of the bits are on.

Returns
  True if none of the bits are set.

Definition at line 1429 of file bitset.

## operator&=()

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::operator&= | ( | const bitset< _Nb > & | __rhs | ) |

inline constexpr noexcept

Operations on bitsets.

Parameters

  __rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 1048 of file bitset.

## operator<<()

template<size_t _Nb>

constexpr bitset< _Nb > std::bitset< _Nb >::operator<< | ( | size_t | __position | ) | const

inline constexpr noexcept

Self-explanatory.

Definition at line 1434 of file bitset.

## operator<<=()

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::operator<<= | ( | size_t | __position | ) |

inline constexpr noexcept

Operations on bitsets.

Parameters

  __position | The number of places to shift.

These should be self-explanatory.

Definition at line 1078 of file bitset.

## operator==()

template<size_t _Nb>

constexpr bool std::bitset< _Nb >::operator== | ( | const bitset< _Nb > & | __rhs | ) | const

inline constexpr noexcept

These comparisons for equality/inequality are, well, bitwise.

Definition at line 1378 of file bitset.

## operator>>()

template<size_t _Nb>

constexpr bitset< _Nb > std::bitset< _Nb >::operator>> | ( | size_t | __position | ) | const

inline constexpr noexcept

Self-explanatory.

Definition at line 1441 of file bitset.

## operator>>=()

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::operator>>= | ( | size_t | __position | ) |

inline constexpr noexcept

Operations on bitsets.

Parameters

  __position | The number of places to shift.

These should be self-explanatory.

Definition at line 1094 of file bitset.

## operator[]() [1/2]

template<size_t _Nb>

constexpr reference std::bitset< _Nb >::operator[] | ( | size_t | __position | ) |

inline constexpr

Array-indexing support.

Parameters

  __position | Index into the bitset.

Returns
  A bool for a const bitset. For non-const bitsets, an instance of the reference proxy class.

Note
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

_GLIBCXX_RESOLVE_LIB_DEFECTS Note that this implementation already resolves DR 11 (items 1 and 2), but does not do the range-checking required by that DR's resolution. -pme The DR has since been changed: range-checking is a precondition (users' responsibility), and these functions must not throw. -pme

Definition at line 1252 of file bitset.

## operator[]() [2/2]

template<size_t _Nb>

constexpr bool std::bitset< _Nb >::operator[] | ( | size_t | __position | ) | const

inline constexpr

Array-indexing support.

Parameters

  __position | Index into the bitset.

Returns
  A bool for a const bitset. For non-const bitsets, an instance of the reference proxy class.

Note
  These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

_GLIBCXX_RESOLVE_LIB_DEFECTS Note that this implementation already resolves DR 11 (items 1 and 2), but does not do the range-checking required by that DR's resolution. -pme The DR has since been changed: range-checking is a precondition (users' responsibility), and these functions must not throw. -pme

Definition at line 1256 of file bitset.

## operator^=()

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::operator^= | ( | const bitset< _Nb > & | __rhs | ) |

inline constexpr noexcept

Operations on bitsets.

Parameters

  __rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 1064 of file bitset.

## operator|=()

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::operator|= | ( | const bitset< _Nb > & | __rhs | ) |

inline constexpr noexcept

Operations on bitsets.

Parameters

  __rhs | A same-sized bitset.

These should be self-explanatory.

Definition at line 1056 of file bitset.

## operator~()

template<size_t _Nb>

constexpr bitset< _Nb > std::bitset< _Nb >::operator~ | ( |  | ) | const

inline constexpr noexcept

See the no-argument flip().

Definition at line 1232 of file bitset.

## reset() [1/2]

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::reset | ( |  | ) |

inline constexpr noexcept

Sets every bit to false.

Definition at line 1183 of file bitset.

## reset() [2/2]

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::reset | ( | size_t | __position | ) |

inline constexpr

Sets a given bit to false.

Parameters

  __position | The index of the bit.

Exceptions

  std::out_of_range | If pos is bigger the size of the set.

Same as writing `set(pos,false)`.

Definition at line 1198 of file bitset.

## set() [1/2]

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::set | ( |  | ) |

inline constexpr noexcept

Sets every bit to true.

Definition at line 1157 of file bitset.

## set() [2/2]

template<size_t _Nb>

constexpr bitset< _Nb > & std::bitset< _Nb >::set | ( | size_t | __position,
|  | bool | __val = `true`
| ) |  |

inline constexpr

Sets a given bit to a particular value.

Parameters

  __position | The index of the bit.
  __val | Either true or false, defaults to true.

Exceptions

  std::out_of_range | If pos is bigger the size of the set.

Definition at line 1172 of file bitset.

## size()

template<size_t _Nb>

constexpr size_t std::bitset< _Nb >::size | ( |  | ) | const

inline constexpr noexcept

Returns the total number of bits.

Definition at line 1371 of file bitset.

## test()

template<size_t _Nb>

constexpr bool std::bitset< _Nb >::test | ( | size_t | __position | ) | const

inline constexpr

Tests the value of a bit.

Parameters

  __position | The index of a bit.

Returns
  The value at pos.

Exceptions

  std::out_of_range | If pos is bigger the size of the set.

Definition at line 1397 of file bitset.

## to_string() [1/8]

template<size_t _Nb>
template<class _CharT , class _Traits , class _Alloc >

constexpr std::basic_string< _CharT, _Traits, _Alloc > std::bitset< _Nb >::to_string | ( |  | ) | const

inline constexpr

Returns a character interpretation of the bitset.

Returns
  The string equivalent of the bits.

Note the ordering of the bits: decreasing character positions correspond to increasing bit positions (see the main class notes for an example).

Definition at line 1290 of file bitset.

## to_string() [2/8]

template<size_t _Nb>
template<class _CharT , class _Traits >

constexpr std::basic_string< _CharT, _Traits, std::allocator< _CharT > > std::bitset< _Nb >::to_string | ( |  | ) | const

inline constexpr

Definition at line 1314 of file bitset.

## to_string() [3/8]

template<size_t _Nb>
template<class _CharT >

constexpr std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > std::bitset< _Nb >::to_string | ( |  | ) | const

inline constexpr

Definition at line 1330 of file bitset.

## to_string() [4/8]

template<size_t _Nb>

constexpr std::basic_string< char, std::char_traits< char >, std::allocator< char > > std::bitset< _Nb >::to_string | ( |  | ) | const

inline constexpr

Definition at line 1348 of file bitset.

## to_string() [5/8]

template<size_t _Nb>
template<class _CharT , class _Traits , class _Alloc >

constexpr std::basic_string< _CharT, _Traits, _Alloc > std::bitset< _Nb >::to_string | ( | _CharT | __zero,
|  | _CharT | __one = `_CharT('1')`
| ) |  | const

inline constexpr

Definition at line 1302 of file bitset.

## to_string() [6/8]

template<size_t _Nb>
template<class _CharT , class _Traits >

constexpr std::basic_string< _CharT, _Traits, std::allocator< _CharT > > std::bitset< _Nb >::to_string | ( | _CharT | __zero,
|  | _CharT | __one = `_CharT('1')`
| ) |  | const

inline constexpr

Definition at line 1322 of file bitset.

## to_string() [7/8]

template<size_t _Nb>
template<class _CharT >

constexpr std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > std::bitset< _Nb >::to_string | ( | _CharT | __zero,
|  | _CharT | __one = `_CharT('1')`
| ) |  | const

inline constexpr

Definition at line 1340 of file bitset.

## to_string() [8/8]

template<size_t _Nb>

constexpr std::basic_string< char, std::char_traits< char >, std::allocator< char > > std::bitset< _Nb >::to_string | ( | char | __zero,
|  | char | __one = `'1'`
| ) |  | const

inline constexpr

Definition at line 1356 of file bitset.

## to_ullong()

template<size_t _Nb>

constexpr unsigned long long std::bitset< _Nb >::to_ullong | ( |  | ) | const

inline constexpr

Definition at line 1274 of file bitset.

## to_ulong()

template<size_t _Nb>

constexpr unsigned long std::bitset< _Nb >::to_ulong | ( |  | ) | const

inline constexpr

Returns a numerical interpretation of the bitset.

Returns
  The integral equivalent of the bits.

Exceptions

  std::overflow_error | If there are too many bits to be represented in an `unsigned` `long`.

Definition at line 1268 of file bitset.

## Friends And Related Symbol Documentation

## reference

template<size_t _Nb>

friend class reference

friend

Definition at line 932 of file bitset.

## std::hash< bitset >

template<size_t _Nb>

friend struct std::hash< bitset >

friend

Definition at line 837 of file bitset.

The documentation for this class was generated from the following file:

- bitset